
{********************************************************}
{                                                        }
{                    XML Data Binding                    }
{                                                        }
{         Generated on: 23.6.2007 9:20:37                }
{       Generated from: C:\M13\mravenci_ukolebavka.xml   }
{   Settings stored in: C:\M13\schema.xdb                }
{                                                        }
{********************************************************}

unit schema;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ Forward Decls }

  IXMLSkladbaType = interface;
  IXMLNotaType = interface;
  IXMLNotaTypeList = interface;
  IXMLPomlkaType = interface;
  IXMLPomlkaTypeList = interface;

{ IXMLSkladbaType }

  IXMLSkladbaType = interface(IXMLNode)
    ['{4AAD322B-DAF2-46AA-B68F-0FCF0E7213A4}']
    { Property Accessors }
    function Get_Takt: WideString;
    function Get_Nota: IXMLNotaTypeList;
    function Get_Pomlka: IXMLPomlkaTypeList;
    procedure Set_Takt(Value: WideString);
    { Methods & Properties }
    property Takt: WideString read Get_Takt write Set_Takt;
    property Nota: IXMLNotaTypeList read Get_Nota;
    property Pomlka: IXMLPomlkaTypeList read Get_Pomlka;
  end;

{ IXMLNotaType }

  IXMLNotaType = interface(IXMLNode)
    ['{99BA1BAF-F55D-4FB3-AD6D-A9FB82D0AF35}']
    { Property Accessors }
    function Get_Delka: WideString;
    function Get_Vyska: WideString;
    procedure Set_Delka(Value: WideString);
    procedure Set_Vyska(Value: WideString);
    { Methods & Properties }
    property Delka: WideString read Get_Delka write Set_Delka;
    property Vyska: WideString read Get_Vyska write Set_Vyska;
  end;

{ IXMLNotaTypeList }

  IXMLNotaTypeList = interface(IXMLNodeCollection)
    ['{59736E70-6974-4E7D-9D45-EC2C017F562F}']
    { Methods & Properties }
    function Add: IXMLNotaType;
    function Insert(const Index: Integer): IXMLNotaType;
    function Get_Item(Index: Integer): IXMLNotaType;
    property Items[Index: Integer]: IXMLNotaType read Get_Item; default;
  end;

{ IXMLPomlkaType }

  IXMLPomlkaType = interface(IXMLNode)
    ['{704406FD-1D4F-48F9-BCEC-0E8239E4E6B0}']
    { Property Accessors }
    function Get_Delka: WideString;
    procedure Set_Delka(Value: WideString);
    { Methods & Properties }
    property Delka: WideString read Get_Delka write Set_Delka;
  end;

{ IXMLPomlkaTypeList }

  IXMLPomlkaTypeList = interface(IXMLNodeCollection)
    ['{01DE6A3F-CB90-4EEC-B8F2-FE4A3107FB3E}']
    { Methods & Properties }
    function Add: IXMLPomlkaType;
    function Insert(const Index: Integer): IXMLPomlkaType;
    function Get_Item(Index: Integer): IXMLPomlkaType;
    property Items[Index: Integer]: IXMLPomlkaType read Get_Item; default;
  end;

{ Forward Decls }

  TXMLSkladbaType = class;
  TXMLNotaType = class;
  TXMLNotaTypeList = class;
  TXMLPomlkaType = class;
  TXMLPomlkaTypeList = class;

{ TXMLSkladbaType }

  TXMLSkladbaType = class(TXMLNode, IXMLSkladbaType)
  private
    FNota: IXMLNotaTypeList;
    FPomlka: IXMLPomlkaTypeList;
  protected
    { IXMLSkladbaType }
    function Get_Takt: WideString;
    function Get_Nota: IXMLNotaTypeList;
    function Get_Pomlka: IXMLPomlkaTypeList;
    procedure Set_Takt(Value: WideString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLNotaType }

  TXMLNotaType = class(TXMLNode, IXMLNotaType)
  protected
    { IXMLNotaType }
    function Get_Delka: WideString;
    function Get_Vyska: WideString;
    procedure Set_Delka(Value: WideString);
    procedure Set_Vyska(Value: WideString);
  end;

{ TXMLNotaTypeList }

  TXMLNotaTypeList = class(TXMLNodeCollection, IXMLNotaTypeList)
  protected
    { IXMLNotaTypeList }
    function Add: IXMLNotaType;
    function Insert(const Index: Integer): IXMLNotaType;
    function Get_Item(Index: Integer): IXMLNotaType;
  end;

{ TXMLPomlkaType }

  TXMLPomlkaType = class(TXMLNode, IXMLPomlkaType)
  protected
    { IXMLPomlkaType }
    function Get_Delka: WideString;
    procedure Set_Delka(Value: WideString);
  end;

{ TXMLPomlkaTypeList }

  TXMLPomlkaTypeList = class(TXMLNodeCollection, IXMLPomlkaTypeList)
  protected
    { IXMLPomlkaTypeList }
    function Add: IXMLPomlkaType;
    function Insert(const Index: Integer): IXMLPomlkaType;
    function Get_Item(Index: Integer): IXMLPomlkaType;
  end;

{ Global Functions }

function Getskladba(Doc: IXMLDocument): IXMLSkladbaType;
function Loadskladba(const FileName: WideString): IXMLSkladbaType;
function Newskladba: IXMLSkladbaType;

const
  TargetNamespace = '';

implementation

{ Global Functions }

function Getskladba(Doc: IXMLDocument): IXMLSkladbaType;
begin
  Result := Doc.GetDocBinding('skladba', TXMLSkladbaType, TargetNamespace) as IXMLSkladbaType;
end;

function Loadskladba(const FileName: WideString): IXMLSkladbaType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('skladba', TXMLSkladbaType, TargetNamespace) as IXMLSkladbaType;
end;

function Newskladba: IXMLSkladbaType;
begin
  Result := NewXMLDocument.GetDocBinding('skladba', TXMLSkladbaType, TargetNamespace) as IXMLSkladbaType;
end;

{ TXMLSkladbaType }

procedure TXMLSkladbaType.AfterConstruction;
begin
  RegisterChildNode('nota', TXMLNotaType);
  RegisterChildNode('pomlka', TXMLPomlkaType);
  FNota := CreateCollection(TXMLNotaTypeList, IXMLNotaType, 'nota') as IXMLNotaTypeList;
  FPomlka := CreateCollection(TXMLPomlkaTypeList, IXMLPomlkaType, 'pomlka') as IXMLPomlkaTypeList;
  inherited;
end;

function TXMLSkladbaType.Get_Takt: WideString;
begin
  Result := AttributeNodes['takt'].Text;
end;

procedure TXMLSkladbaType.Set_Takt(Value: WideString);
begin
  SetAttribute('takt', Value);
end;

function TXMLSkladbaType.Get_Nota: IXMLNotaTypeList;
begin
  Result := FNota;
end;

function TXMLSkladbaType.Get_Pomlka: IXMLPomlkaTypeList;
begin
  Result := FPomlka;
end;

{ TXMLNotaType }

function TXMLNotaType.Get_Delka: WideString;
begin
  Result := AttributeNodes['delka'].Text;
end;

procedure TXMLNotaType.Set_Delka(Value: WideString);
begin
  SetAttribute('delka', Value);
end;

function TXMLNotaType.Get_Vyska: WideString;
begin
  Result := AttributeNodes['vyska'].Text;
end;

procedure TXMLNotaType.Set_Vyska(Value: WideString);
begin
  SetAttribute('vyska', Value);
end;

{ TXMLNotaTypeList }

function TXMLNotaTypeList.Add: IXMLNotaType;
begin
  Result := AddItem(-1) as IXMLNotaType;
end;

function TXMLNotaTypeList.Insert(const Index: Integer): IXMLNotaType;
begin
  Result := AddItem(Index) as IXMLNotaType;
end;
function TXMLNotaTypeList.Get_Item(Index: Integer): IXMLNotaType;
begin
  Result := List[Index] as IXMLNotaType;
end;

{ TXMLPomlkaType }

function TXMLPomlkaType.Get_Delka: WideString;
begin
  Result := AttributeNodes['delka'].Text;
end;

procedure TXMLPomlkaType.Set_Delka(Value: WideString);
begin
  SetAttribute('delka', Value);
end;

{ TXMLPomlkaTypeList }

function TXMLPomlkaTypeList.Add: IXMLPomlkaType;
begin
  Result := AddItem(-1) as IXMLPomlkaType;
end;

function TXMLPomlkaTypeList.Insert(const Index: Integer): IXMLPomlkaType;
begin
  Result := AddItem(Index) as IXMLPomlkaType;
end;
function TXMLPomlkaTypeList.Get_Item(Index: Integer): IXMLPomlkaType;
begin
  Result := List[Index] as IXMLPomlkaType;
end;

end.